--- errors_zh_TW.properties.orig	Wed Feb 12 05:58:29 2003
+++ errors_zh_TW.properties	Wed Feb 12 06:13:10 2003
@@ -1,93 +1,95 @@
-# 2002-06-24 Zhenbang Wei <forth@mail.net.tw>
+# 2003-02-11 Zhenbang Wei <forth@zbwei.net>
 postgresql.arr.range:\u9663\u5217\u7d22\u5f15\u8d85\u904e\u8a31\u53ef\u7bc4\u570d\u3002
 postgresql.drv.version:\u5167\u90e8\u932f\u8aa4\uff0c\u8acb\u91cd\u65b0\u7de8\u8b6f\u9a45\u52d5\u7a0b\u5f0f\u3002
-postgresql.con.auth:\u4e0d\u652f\u63f4 {0} \u8a8d\u8b49\uff0c\u8acb\u78ba\u5b9a\u60a8\u5df2\u7d93\u5c07\u5ba2\u6236\u7aef\u7684 IP \u4f4d\u5740\u6216\u7db2\u8def\u5340\u6bb5\u4ee5\u53ca\u9a45\u52d5\u7a0b\u5f0f\u6240\u652f\u63f4\u7684\u8a8d\u8b49\u985e\u578b\u52a0\u5165 pg_hba.conf\u3002
+postgresql.con.auth:\u4e0d\u652f\u63f4{0}\u8a8d\u8b49\uff0c\u8acb\u78ba\u5b9a\u60a8\u5df2\u7d93\u5c07\u5ba2\u6236\u7aef\u7684IP\u4f4d\u5740\u6216\u7db2\u8def\u5340\u6bb5\u4ee5\u53ca\u9a45\u52d5\u7a0b\u5f0f\u6240\u652f\u63f4\u7684\u8a8d\u8b49\u985e\u578b\u52a0\u5165pg_hba.conf\u3002
 postgresql.con.authfail:\u8b80\u53d6\u8a8d\u8b49\u8acb\u6c42\u6642\u767c\u751f\u932f\u8aa4\u3002
-postgresql.con.backend:\u5f8c\u7aef\u555f\u52d5\u5931\u6557: {0}
-postgresql.con.call:\u76ee\u524d\u4e0d\u652f\u63f4 CallableStatement\u3002
-postgresql.con.creobj:\u70ba {0} {1} \u5efa\u7acb\u7269\u4ef6\u5931\u6557
-postgresql.con.failed:\u7121\u6cd5\u9023\u7dda\uff0c\u56e0\u70ba {0}
-postgresql.con.fathom:\u7121\u6cd5\u53d6\u5f97\u66f4\u65b0\u7684\u8cc7\u6599\u7b46\u6578 {0}
+postgresql.con.backend:\u5f8c\u7aef\u555f\u52d5\u5931\u6557\uff1a{0}
+postgresql.con.call:\u76ee\u524d\u4e0d\u652f\u63f4CallableStatement\u3002
+postgresql.con.invalidchar:\u767c\u73fe\u4e0d\u5408\u6cd5\u7684\u5b57\u5143\uff0c\u53ef\u80fd\u7684\u539f\u56e0\u662f\u6b32\u5132\u5b58\u7684\u8cc7\u6599\u4e2d\u5305\u542b\u8cc7\u6599\u5eab\u7684\u5b57\u5143\u96c6\u4e0d\u652f\u63f4\u7684\u5b57\u78bc\uff0c\u5176\u4e2d\u6700\u5e38\u898b\u4f8b\u5b50\u7684\u5c31\u662f\u5c078\u4f4d\u5143\u8cc7\u6599\u5b58\u5165\u4f7f\u7528SQL_ASCII\u7684\u8cc7\u6599\u5eab\u3002
+postgresql.con.closed:\u9023\u7dda\u5df2\u95dc\u9589\uff0c\u4e0d\u5141\u8a31\u64cd\u4f5c\u3002
+postgresql.con.creobj:\u70ba{0} {1}\u5efa\u7acb\u7269\u4ef6\u5931\u6557
+postgresql.con.failed:\u7121\u6cd5\u9023\u7dda\uff0c\u56e0\u70ba{0}
+postgresql.con.fathom:\u7121\u6cd5\u53d6\u5f97\u66f4\u65b0\u7684\u8cc7\u6599\u7b46\u6578{0}
 postgresql.con.garbled:\u6536\u5230\u7121\u6548\u7684\u8cc7\u6599\u3002
-postgresql.con.ioerror:\u50b3\u9001\u8cc7\u6599\u81f3\u5f8c\u7aef\u6642\u767c\u751f IO \u932f\u8aa4 - {0}
-postgresql.con.kerb4:\u9a45\u52d5\u7a0b\u5f0f\u4e0d\u652f\u63f4 Kerberos 4 \u8a8d\u8b49\u3002
-postgresql.con.kerb5:\u9a45\u52d5\u7a0b\u5f0f\u4e0d\u652f\u63f4 Kerberos 5 \u8a8d\u8b49\u3002
+postgresql.con.ioerror:\u50b3\u9001\u8cc7\u6599\u81f3\u5f8c\u7aef\u6642\u767c\u751fIO\u932f\u8aa4 - {0}
+postgresql.con.kerb4:\u9a45\u52d5\u7a0b\u5f0f\u4e0d\u652f\u63f4Kerberos 4\u8a8d\u8b49\u3002
+postgresql.con.kerb5:\u9a45\u52d5\u7a0b\u5f0f\u4e0d\u652f\u63f4Kerberos 5\u8a8d\u8b49\u3002
 postgresql.con.misc:\u767c\u751f\u9023\u7dda\u932f\u8aa4\uff1a{0}
 postgresql.con.multres:\u7121\u6cd5\u8655\u7406\u591a\u91cd\u67e5\u8a62\u7d50\u679c\u3002
-postgresql.con.pass:\u6c92\u6709 password \u5c6c\u6027\uff0c\u9019\u9805\u5c6c\u6027\u662f\u5fc5\u9700\u7684\u3002
-postgresql.con.refused:\u62d2\u7d55\u9023\u7dda\uff0c\u8acb\u6aa2\u67e5\u4e3b\u6a5f\u540d\u7a31\u548c\u57e0\u865f\uff0c\u4e26\u78ba\u5b9a postmaster \u555f\u52d5\u6642\u4f7f\u7528\u4e86 -i \u53c3\u6578\u958b\u555f TCP/IP \u7db2\u8def\u529f\u80fd\u3002
-postgresql.con.setup:\u901a\u8a0a\u5354\u5b9a\u932f\u8aa4\u3002Session \u521d\u59cb\u5316\u5931\u6557\u3002
+postgresql.con.pass:\u6c92\u6709password\u5c6c\u6027\uff0c\u9019\u9805\u5c6c\u6027\u662f\u5fc5\u9700\u7684\u3002
+postgresql.con.refused:\u62d2\u7d55\u9023\u7dda\uff0c\u8acb\u6aa2\u67e5\u4e3b\u6a5f\u540d\u7a31\u548c\u57e0\u865f\uff0c\u4e26\u78ba\u5b9apostmaster\u555f\u52d5\u6642\u4f7f\u7528\u4e86-i\u53c3\u6578\u958b\u555fTCP/IP\u7db2\u8def\u529f\u80fd\u3002
+postgresql.con.setup:\u901a\u8a0a\u5354\u5b9a\u932f\u8aa4\u3002Session\u521d\u59cb\u5316\u5931\u6557\u3002
 postgresql.con.strobj:\u7121\u6cd5\u5132\u5b58\u7269\u4ef6\uff0c\u8acb\u78ba\u5b9a\u5df2\u7d93\u5728\u8cc7\u6599\u5eab\u4e2d\u5efa\u7acb\u8981\u4f7f\u7528\u7684\u8cc7\u6599\u8868\u3002
 postgresql.con.strobjex:\u5132\u5b58\u7269\u4ef6\u5931\u6557 - {0}
 postgresql.con.toolong:SQL \u6558\u8ff0\u904e\u9577 - {0}
-postgresql.con.isolevel:\u4e0d\u652f\u63f4\u4ea4\u6613\u9694\u7d55\u7b49\u7d1a {0}\u3002
-postgresql.con.tuple:Tuple \u5728 MetaData \u4e4b\u524d\u50b3\u56de\u3002
-postgresql.con.type:\u4e0d\u660e\u7684\u56de\u61c9\u985e\u578b {0}
-postgresql.con.user:\u6c92\u6709 user \u5c6c\u6027\uff0c\u9019\u9805\u5c6c\u6027\u662f\u5fc5\u9700\u7684\u3002
-postgresql.fp.error:FastPath \u547c\u53eb\u50b3\u56de {0}
-postgresql.fp.expint:Fastpath \u547c\u53eb {0} - \u6c92\u6709\u50b3\u56de\u503c\uff0c\u61c9\u8a72\u50b3\u56de\u4e00\u500b\u6574\u6578\u3002
-postgresql.fp.protocol:FastPath \u5354\u5b9a\u932f\u8aa4\uff1a{0}
-postgresql.fp.send:\u50b3\u9001 fastpath \u547c\u53eb {0} {1} \u5931\u6557
-postgresql.fp.unknown:\u4e0d\u660e\u7684 fastpath \u51fd\u5f0f {0}\u3002
-postgresql.geo.box:\u8f49\u63db box \u5931\u6557 - {0}
-postgresql.geo.circle:\u8f49\u63db circle \u5931\u6557 - {0}
-postgresql.geo.line:\u8f49\u63db line \u5931\u6557 - {0}
-postgresql.geo.lseg:\u8f49\u63db lseg \u5931\u6557 - {0}
-postgresql.geo.path:\u7121\u6cd5\u5f97\u77e5 path \u662f\u95dc\u9589\u6216\u958b\u555f\u3002
-postgresql.geo.point:\u8f49\u63db point \u5931\u6557 - {0}
-postgresql.jvm.version:\u5728 postgresql.jar \u4e2d\u627e\u4e0d\u5230\u6b63\u78ba\u7684 JDBC \u985e\u5225\u4f9b JVM \u4f7f\u7528\uff0c\u8acb\u91cd\u65b0\u7de8\u8b6f\uff0c\u5982\u679c\u4ecd\u7136\u767c\u751f\u932f\u8aa4\uff0c\u8acb\u5728\u57f7\u884c\u6642\u7528 -Djava.version=1.1 \u6216 -Djava.version=1.2 \u5f37\u5236\u6307\u5b9a\u7248\u672c\n\u7522\u751f\u7684\u4f8b\u5916\u662f {0}
-postgresql.lo.init:\u521d\u59cb\u5316 LargeObject API \u5931\u6557\u3002
-postgresql.metadata.unavailable:\u7121\u6cd5\u53d6\u5f97 Metadata\u3002
-postgresql.money:\u8f49\u63db money \u5931\u6557 - {0}\u3002
+postgresql.con.isolevel:\u4e0d\u652f\u63f4\u4ea4\u6613\u9694\u7d55\u7b49\u7d1a{0}\u3002
+postgresql.con.tuple:Tuple\u5728MetaData\u4e4b\u524d\u50b3\u56de\u3002
+postgresql.con.type:\u4e0d\u660e\u7684\u56de\u61c9\u985e\u578b{0}
+postgresql.con.user:\u6c92\u6709user\u5c6c\u6027\uff0c\u9019\u9805\u5c6c\u6027\u662f\u5fc5\u9700\u7684\u3002
+postgresql.fp.error:FastPath\u547c\u53eb\u50b3\u56de{0}
+postgresql.fp.expint:Fastpath\u547c\u53eb{0} - \u6c92\u6709\u50b3\u56de\u503c\uff0c\u61c9\u8a72\u50b3\u56de\u4e00\u500b\u6574\u6578\u3002
+postgresql.fp.protocol:FastPath\u5354\u5b9a\u932f\u8aa4\uff1a{0}
+postgresql.fp.send:\u50b3\u9001fastpath\u547c\u53eb{0} {1}\u5931\u6557
+postgresql.fp.unknown:\u4e0d\u660e\u7684fastpath\u51fd\u5f0f{0}\u3002
+postgresql.geo.box:\u8f49\u63dbbox\u5931\u6557 - {0}
+postgresql.geo.circle:\u8f49\u63dbcircle\u5931\u6557 - {0}
+postgresql.geo.line:\u8f49\u63dbline\u5931\u6557 - {0}
+postgresql.geo.lseg:\u8f49\u63dblseg\u5931\u6557 - {0}
+postgresql.geo.path:\u7121\u6cd5\u5f97\u77e5path\u662f\u95dc\u9589\u6216\u958b\u555f\u3002
+postgresql.geo.point:\u8f49\u63dbpoint\u5931\u6557 - {0}
+postgresql.jvm.version:\u5728postgresql.jar\u4e2d\u627e\u4e0d\u5230\u6b63\u78ba\u7684JDBC\u985e\u5225\u4f9bJVM\u4f7f\u7528\uff0c\u8acb\u91cd\u65b0\u7de8\u8b6f\uff0c\u5982\u679c\u4ecd\u7136\u767c\u751f\u932f\u8aa4\uff0c\u8acb\u5728\u57f7\u884c\u6642\u7528-Djava.version=1.1\u6216-Djava.version=1.2\u5f37\u5236\u6307\u5b9a\u7248\u672c\n\u7522\u751f\u7684\u4f8b\u5916\u662f{0}
+postgresql.lo.init:\u521d\u59cb\u5316LargeObject API\u5931\u6557\u3002
+postgresql.metadata.unavailable:\u7121\u6cd5\u53d6\u5f97Metadata\u3002
+postgresql.money:\u8f49\u63dbmoney\u5931\u6557 - {0}\u3002
 postgresql.noupdate:\u67e5\u8a62\u7d50\u679c\u4e0d\u53ef\u66f4\u65b0\u3002
 postgresql.notsensitive:\u67e5\u8a62\u7d50\u679c\u4e0d\u80fd\u5373\u6642\u53cd\u6620\u8b8a\u52d5\u7684\u8cc7\u6599\u3002
 postgresql.psqlnotimp:\u5f8c\u7aef\u76ee\u524d\u4e0d\u652f\u63f4\u9019\u9805\u529f\u80fd\u3002
-postgresql.prep.is:\u4e0d\u652f\u63f4\u4ee5 InputStream \u505a\u70ba\u53c3\u6578\u3002
-postgresql.prep.param:\u672a\u8a2d\u5b9a\u53c3\u6578 {0} \u7684\u5167\u5bb9\u3002
+postgresql.prep.is:\u4e0d\u652f\u63f4\u4ee5InputStream\u505a\u70ba\u53c3\u6578\u3002
+postgresql.prep.param:\u672a\u8a2d\u5b9a\u53c3\u6578{0}\u7684\u5167\u5bb9\u3002
 postgresql.prep.range:\u53c3\u6578\u7d22\u5f15\u8d85\u904e\u8a31\u53ef\u7bc4\u570d\u3002
 postgresql.prep.type:\u4e0d\u660e\u7684\u578b\u5225\u3002
-postgresql.res.badbigdec:\u932f\u8aa4\u7684 BigDecimal {0}
-postgresql.res.badbyte:\u932f\u8aa4\u7684 Byte {0}
-postgresql.res.baddate:\u932f\u8aa4\u7684 Date \u683c\u5f0f {1} \u65bc {0}
-postgresql.res.baddouble:\u932f\u8aa4\u7684 Double {0}
-postgresql.res.badfloat:\u932f\u8aa4\u7684 Float {0}
-postgresql.res.badint:\u932f\u8aa4\u7684 Integer {0}
-postgresql.res.badlong:\u932f\u8aa4\u7684 Long {0}
-postgresql.res.badshort:\u932f\u8aa4\u7684 Short {0}
-postgresql.res.badtime:\u932f\u8aa4\u7684 Time {0}
-postgresql.res.badtimestamp:\u932f\u8aa4\u7684 Timestamp \u683c\u5f0f {1} \u65bc {0}
-postgresql.res.closed:ResultSet \u5df2\u7d93\u95dc\u9589\uff0c\u4e0d\u5141\u8a31\u5176\u5b83\u64cd\u4f5c\u3002
-postgresql.res.colname:\u627e\u4e0d\u5230\u6b04\u4f4d\u540d\u7a31 {0}\u3002
+postgresql.res.badbigdec:\u932f\u8aa4\u7684BigDecimal {0}
+postgresql.res.badbyte:\u932f\u8aa4\u7684Byte {0}
+postgresql.res.baddate:\u932f\u8aa4\u7684Date\u683c\u5f0f {1} \u65bc {0}
+postgresql.res.baddouble:\u932f\u8aa4\u7684Double {0}
+postgresql.res.badfloat:\u932f\u8aa4\u7684Float {0}
+postgresql.res.badint:\u932f\u8aa4\u7684Integer {0}
+postgresql.res.badlong:\u932f\u8aa4\u7684Long {0}
+postgresql.res.badshort:\u932f\u8aa4\u7684Short {0}
+postgresql.res.badtime:\u932f\u8aa4\u7684Time {0}
+postgresql.res.badtimestamp:\u932f\u8aa4\u7684Timestamp\u683c\u5f0f{1}\u65bc{0}
+postgresql.res.closed:ResultSet\u5df2\u7d93\u95dc\u9589\uff0c\u4e0d\u5141\u8a31\u5176\u5b83\u64cd\u4f5c\u3002
+postgresql.res.colname:\u627e\u4e0d\u5230\u6b04\u4f4d\u540d\u7a31{0}\u3002
 postgresql.res.colrange:\u6b04\u4f4d\u7d22\u5f15\u8d85\u904e\u8a31\u53ef\u7bc4\u570d\u3002
-postgresql.res.nextrequired:\u67e5\u8a62\u7d50\u679c\u6307\u6a19\u4f4d\u7f6e\u4e0d\u6b63\u78ba\uff0c\u60a8\u4e5f\u8a31\u9700\u8981\u547c\u53eb ResultSet \u7684 next() \u65b9\u6cd5\u3002
+postgresql.res.nextrequired:\u67e5\u8a62\u7d50\u679c\u6307\u6a19\u4f4d\u7f6e\u4e0d\u6b63\u78ba\uff0c\u60a8\u4e5f\u8a31\u9700\u8981\u547c\u53ebResultSet\u7684next()\u65b9\u6cd5\u3002
 postgresql.serial.interface:\u4e0d\u5141\u8a31\u5c07\u4ecb\u9762\u5e8f\u5217\u5316\u3002
-postgresql.serial.namelength:\u985e\u5225\u548c\u5305\u88dd\u7684\u540d\u7a31\uff0c\u9577\u5ea6\u4e0d\u80fd\u8d85\u904e 32 \u5b57\u5143\uff0c{0} \u7684\u9577\u5ea6\u662f {1} \u5b57\u5143\u3002
-postgresql.serial.noclass:\u627e\u4e0d\u5230\u985e\u5225 {0}\u3002
-postgresql.serial.table:\u8655\u7406 {0} \u6642\u627e\u4e0d\u5230\u8cc7\u6599\u8868\uff0c\u8cc7\u6599\u5eab\u72c0\u614b\u4e0d\u6b63\u5e38\uff0c\u8acb\u806f\u7d61 DBA \u8655\u7406\u3002
-postgresql.serial.underscore:\u985e\u5225\u540d\u7a31\u4e0d\u80fd\u4f7f\u7528 _ \u5b57\u5143\uff0c\u60a8\u7528\u7684\u540d\u7a31\u662f {0}\u3002
-postgresql.stat.batch.error:\u6279\u6b21\u8655\u7406\u5ffd\u7565 {0} {1}\u3002
-postgresql.stat.maxfieldsize:setMaxFieldSize() \u5931\u6557 - \u4f7f\u7528\u9810\u8a2d\u503c
+postgresql.serial.namelength:\u985e\u5225\u548c\u5305\u88dd\u7684\u540d\u7a31\uff0c\u9577\u5ea6\u4e0d\u80fd\u8d85\u904e32\u5b57\u5143\uff0c{0}\u7684\u9577\u5ea6\u662f{1}\u5b57\u5143\u3002
+postgresql.serial.noclass:\u627e\u4e0d\u5230\u985e\u5225{0}\u3002
+postgresql.serial.table:\u8655\u7406{0}\u6642\u627e\u4e0d\u5230\u8cc7\u6599\u8868\uff0c\u8cc7\u6599\u5eab\u72c0\u614b\u4e0d\u6b63\u5e38\uff0c\u8acb\u806f\u7d61DBA\u8655\u7406\u3002
+postgresql.serial.underscore:\u985e\u5225\u540d\u7a31\u4e0d\u80fd\u4f7f\u7528_\u5b57\u5143\uff0c\u60a8\u6240\u7528\u7684\u540d\u7a31\u662f{0}\u3002
+postgresql.stat.batch.error:\u6279\u6b21\u8655\u7406\u5ffd\u7565{0} {1}\u3002
+postgresql.stat.maxfieldsize:setMaxFieldSize()\u5931\u6557 - \u4f7f\u7528\u9810\u8a2d\u503c
 postgresql.stat.noresult:\u6c92\u6709\u50b3\u56de\u4efb\u4f55\u67e5\u8a62\u7d50\u679c\u3002
 postgresql.stream.eof:\u5f8c\u7aef\u7d50\u675f\u9023\u7dda\uff0c\u4e5f\u8a31\u662f\u56e0\u70ba\u60a8\u6240\u57f7\u884c\u7684\u52d5\u4f5c\u5c0e\u81f4\u9023\u7dda\u4e2d\u65b7\u3002
-postgresql.stream.flush:\u9001\u51fa\u8cc7\u6599\u6642\u767c\u751f I/O \u932f\u8aa4 - {0}
-postgresql.stream.ioerror:\u5f9e\u5f8c\u7aef\u8b80\u53d6\u8cc7\u6599\u6642\u767c\u751f I/O \u932f\u8aa4 - {0}
+postgresql.stream.flush:\u9001\u51fa\u8cc7\u6599\u6642\u767c\u751fI/O\u932f\u8aa4 - {0}
+postgresql.stream.ioerror:\u5f9e\u5f8c\u7aef\u8b80\u53d6\u8cc7\u6599\u6642\u767c\u751fI/O\u932f\u8aa4 - {0}
 postgresql.stream.toomuch:\u63a5\u6536\u904e\u591a\u8cc7\u6599\u3002
 postgresql.unusual:\u4e0d\u660e\u7684\u539f\u56e0\u5c0e\u81f4\u9a45\u52d5\u7a0b\u5f0f\u767c\u751f\u932f\u8aa4\uff0c\u8acb\u56de\u5831\u9019\u500b\u4f8b\u5916\uff1a{0}
 postgresql.unimplemented:\u9019\u500b\u65b9\u6cd5\u5c1a\u672a\u5be6\u4f5c\u3002
 postgresql.unexpected:\u50b3\u56de\u975e\u9810\u671f\u7684\u67e5\u8a62\u7d50\u679c\u3002
-postgresql.updateable.notupdateable:\u4e0d\u53ef\u66f4\u65b0\u7684 ResultSet\u3002\u7528\u4f86\u7522\u751f\u9019\u500b ResultSet \u7684 SQL \u6307\u4ee4\u53ea\u80fd\u64cd\u4f5c\u4e00\u500b\u8cc7\u6599\u8868\uff0c\u4e26\u4e14\u5fc5\u9700\u9078\u64c7\u4e3b\u9375\u6b04\u4f4d\uff0c\u8acb\u53c3\u95b1 JDBC 2.1 API \u898f\u683c\u66f8 5.6 \u7bc0\u3002
-postgresql.updateable.oninsertrow:\u6b63\u5728\u65b0\u589e\u4e00\u7b46\u8cc7\u6599\u6642\u4e0d\u884c\u547c\u53eb deleteRow() \u65b9\u6cd5\u3002
-postgresql.updateable.emptydelete:\u4e0d\u884c\u5728\u7a7a\u7684 ResultSet \u4f7f\u7528 deleteRow() \u65b9\u6cd5\u3002
-postgresql.updateable.beforestartdelete:\u4e0d\u884c\u5728 ResultSet \u7684\u7b2c\u4e00\u7b46\u8cc7\u6599\u4e4b\u524d\u547c\u53eb deleteRow() \u65b9\u6cd5\u3002
-postgresql.updateable.afterlastdelete:\u4e0d\u884c\u5728 ResultSet \u7684\u6700\u5f8c\u4e00\u7b46\u8cc7\u6599\u4e4b\u5f8c\u547c\u53eb deleteRow() \u65b9\u6cd5\u3002
+postgresql.updateable.notupdateable:\u4e0d\u53ef\u66f4\u65b0\u7684ResultSet\u3002\u7528\u4f86\u7522\u751f\u9019\u500bResultSet\u7684SQL\u6307\u4ee4\u53ea\u80fd\u64cd\u4f5c\u4e00\u500b\u8cc7\u6599\u8868\uff0c\u4e26\u4e14\u5fc5\u9700\u9078\u64c7\u4e3b\u9375\u6b04\u4f4d\uff0c\u8acb\u53c3\u95b1JDBC 2.1 API\u898f\u683c\u66f85.6\u7bc0\u3002
+postgresql.updateable.oninsertrow:\u6b63\u5728\u65b0\u589e\u4e00\u7b46\u8cc7\u6599\u6642\u4e0d\u884c\u547c\u53ebdeleteRow()\u65b9\u6cd5\u3002
+postgresql.updateable.emptydelete:\u4e0d\u884c\u5728\u7a7a\u7684ResultSet\u4f7f\u7528deleteRow()\u65b9\u6cd5\u3002
+postgresql.updateable.beforestartdelete:\u4e0d\u884c\u5728ResultSet\u7684\u7b2c\u4e00\u7b46\u8cc7\u6599\u4e4b\u524d\u547c\u53ebdeleteRow()\u65b9\u6cd5\u3002
+postgresql.updateable.afterlastdelete:\u4e0d\u884c\u5728ResultSet\u7684\u6700\u5f8c\u4e00\u7b46\u8cc7\u6599\u4e4b\u5f8c\u547c\u53ebdeleteRow()\u65b9\u6cd5\u3002
 postgresql.updateable.notoninsertrow:\u4e0d\u5728\u65b0\u589e\u7684\u8cc7\u6599\u5217\u4e0a\u3002
-postgresql.updateable.inputstream:InputStream \u662f null\u3002
-postgresql.updateable.ioerror:InputStream \u932f\u8aa4\u3002
-postgresql.call.noreturntype:\u5df2\u7d93\u5ba3\u544a CallableStatement \u51fd\u5f0f\uff0c\u4f46\u662f\u5c1a\u672a\u547c\u53eb'registerOutParameter (1, <some_type>)'\u3002
-postgresql.call.noinout:PostgreSQL \u53ea\u652f\u63f4\u50b3\u56de\u503c\u70ba [@ 1] \u7684\u51fd\u5f0f(\u6c92\u6709 OUT \u6216 INPUT \u5f15\u6578)\u3002
-postgresql.call.procasfunc:\u6558\u8ff0 [{0}] \u5b9a\u7fa9\u4e86\u4e00\u500b\u9810\u5132\u7a0b\u5e8f(\u547c\u53eb\u51fd\u5f0f\u9700\u8981\u4f7f\u7528 ?= call <stmt> \u683c\u5f0f)\u3002
-postgresql.call.malformed:\u932f\u8aa4\u7684\u6558\u8ff0 [{0}] \u7528\u6cd5 : {1}
-postgresql.call.funcover:\u7121\u6cd5\u57f7\u884c\u67e5\u8a62\uff0c\u547c\u53eb\u4e86 setXXX(1, ..)\uff0c\u4f46\u662f\u7b2c\u4e00\u500b\u5f15\u6578\u662f\u51fd\u5f0f\u7684\u50b3\u56de\u503c\u3002
-postgresql.call.wrongget:\u5df2\u8a3b\u518a\u53c3\u6578\u578b\u5225 {0}\uff0c\u4f46\u662f\u53c8\u547c\u53eb\u4e86 get{1}(sqltype={2})\u3002
-postgresql.call.noreturnval:CallableStatement \u57f7\u884c\u51fd\u5f0f\u5f8c\u6c92\u6709\u50b3\u56de\u503c\u3002
-postgresql.call.wrongrtntype:CallableStatement \u57f7\u884c\u51fd\u5f0f\u5f8c\u50b3\u56de\u503c\u7684\u578b\u5225\u662f {0}\uff0c\u4f46\u662f\u8a3b\u518a\u7684\u578b\u5225\u662f {1}\u3002
+postgresql.updateable.inputstream:InputStream\u662fnull\u3002
+postgresql.updateable.ioerror:InputStream\u932f\u8aa4\u3002
+postgresql.call.noreturntype:\u5df2\u7d93\u5ba3\u544aCallableStatement\u51fd\u5f0f\uff0c\u4f46\u662f\u5c1a\u672a\u547c\u53eb'registerOutParameter (1, <some_type>)'\u3002
+postgresql.call.noinout:PostgreSQL\u53ea\u652f\u63f4\u50b3\u56de\u503c\u70ba[@ 1]\u7684\u51fd\u5f0f(\u6c92\u6709OUT\u6216INPUT\u5f15\u6578)\u3002
+postgresql.call.procasfunc:\u6558\u8ff0[{0}]\u5b9a\u7fa9\u4e86\u4e00\u500b\u9810\u5132\u7a0b\u5e8f(\u547c\u53eb\u51fd\u5f0f\u9700\u8981\u4f7f\u7528?= call <stmt>\u683c\u5f0f)\u3002
+postgresql.call.malformed:\u932f\u8aa4\u7684\u6558\u8ff0[{0}]\u7528\u6cd5\uff1a{1}
+postgresql.call.funcover:\u7121\u6cd5\u57f7\u884c\u67e5\u8a62\uff0c\u547c\u53eb\u4e86setXXX(1, ..)\uff0c\u4f46\u662f\u7b2c\u4e00\u500b\u5f15\u6578\u662f\u51fd\u5f0f\u7684\u50b3\u56de\u503c\u3002
+postgresql.call.wrongget:\u5df2\u8a3b\u518a\u53c3\u6578\u578b\u5225{0}\uff0c\u4f46\u662f\u53c8\u547c\u53eb\u4e86get{1}(sqltype={2})\u3002
+postgresql.call.noreturnval:CallableStatement\u57f7\u884c\u51fd\u5f0f\u5f8c\u6c92\u6709\u50b3\u56de\u503c\u3002
+postgresql.call.wrongrtntype:CallableStatement\u57f7\u884c\u51fd\u5f0f\u5f8c\u50b3\u56de\u503c\u7684\u578b\u5225\u662f{0}\uff0c\u4f46\u662f\u8a3b\u518a\u7684\u578b\u5225\u662f{1}\u3002